#include <GUIConstantsEx.au3>
#include <Constants.au3>
#include <EditConstants.au3>
#include <WindowsConstants.au3>
#include <WinAPI.au3>
#include <Misc.au3>
;

#Region Vars Part
Global Const $WM_EXITSIZEMOVE = 0x232
Global Const $WM_MOUSEWHEEL = 0x020A
Global Const $WM_MBUTTONUP = 0x0207
Global Const $SC_MOVE = 0xF010
Global Const $SC_SIZE = 0xF000

Global $hUser32_Dll = DllOpen("User32.dll")

Global $iMoveWithCursor = False
Global $aOld_Mouse_Pos = MouseGetPos()
Global $iOld_DragFullWindows_Opt = RegRead("HKEY_CURRENT_USER\Control Panel\Desktop", "DragFullWindows")

Global $sAppName = "Reading Ruler"

Global $sConfigFile = StringTrimRight(@ScriptFullPath, 3) & "ini"

Global $aBk_Colors = StringSplit(IniRead($sConfigFile, "Main", _
		"Bk Colors List", _
		"0xFFFF80,0x80BFFF,0xBFDFDF,0xAEAE00,0xD50000,0xFF8000,0x00FFFF,0xFF0000,0x8000FF,0x0000FF"), ",")

Global $aTransparency = StringSplit(IniRead($sConfigFile, "Main", "Transparency List", "230,200,170,140,110,80,50,40,30,20"), ",")

Global $iLine_Color = IniRead($sConfigFile, "Main", "Line Color", 0x4A4A4A)
Global $iLine_Height = IniRead($sConfigFile, "Main", "Line Height", 10)
Global $iCurrent_Bk_Color = IniRead($sConfigFile, "Main", "Bk Color Level", 1)
Global $iCurrent_Transparency = IniRead($sConfigFile, "Main", "Transparency Level", 5)

Global $iView_Mode = IniRead($sConfigFile, "Main", "View Mode", 1)

Global $iWidth_NormalVMode = IniRead($sConfigFile, "Normal View Mode", "GUI Width", 600)
Global $iHeight_NormalVMode = IniRead($sConfigFile, "Normal View Mode", "GUI Height", 300)
Global $iLeft_NormalVMode = IniRead($sConfigFile, "Normal View Mode", "GUI Left", -1)
Global $iTop_NormalVMode = IniRead($sConfigFile, "Normal View Mode", "GUI Top", -1)

Global $iWidth_MaxVMode = IniRead($sConfigFile, "Max View Mode", "GUI Width", @DesktopWidth)
Global $iHeight_MaxVMode = IniRead($sConfigFile, "Max View Mode", "GUI Height", 300)
Global $iLeft_MaxVMode = IniRead($sConfigFile, "Max View Mode", "GUI Top", 0)
Global $iTop_MaxVMode = IniRead($sConfigFile, "Max View Mode", "GUI Top", -1)

Global $iShowCursor_NormalVMode = IniRead($sConfigFile, "Normal View Mode", "Show Cursor", 0)
Global $iShowCursor_MaxVMode = IniRead($sConfigFile, "Max View Mode", "Show Cursor", 1)

Global $sShow_MainGUI_HotKey = IniRead($sConfigFile, "Main", "Show GUI HotKey", "^+l")
Global $sHide_MainGUI_HotKey = IniRead($sConfigFile, "Main", "Hide GUI HotKey", "^+l")

Global $iMainGUI_IsShown = True

Global $iGUI_Width = $iWidth_NormalVMode
Global $iGUI_Height = $iHeight_NormalVMode
Global $iGUI_Left = $iLeft_NormalVMode
Global $iGUI_Top = $iTop_NormalVMode

If $iGUI_Left = -1 Then $iGUI_Left = (@DesktopWidth / 2) - ($iGUI_Width / 2)
If $iGUI_Top = -1 Then $iGUI_Top = (@DesktopHeight / 2) - ($iGUI_Height / 2)

;Setting and controls IDs
Global $hBk_GUI = -1, $hLine_GUI = -1, $hSettings_GUI = -1
Global $nSts_BkColor_Input = -1, $nSts_Trans_Input = -1, $nSts_LineHeight_Input, $nSts_LineColor_Button = -1
Global $nSts_NormalVMode_ShowCursor_CB = -1, $nSts_MaxVMode_ShowCursor_CB = -1
Global $nSts_Apply_Button = -1, $nSts_OK_Button = -1, $nSts_Cancel_Button = -1, $nSts_ResDefaults_Button = -1
#EndRegion Vars Part
;

#Region Tray Part
Opt("TrayMenuMode", 3)
Opt("TrayOnEventMode", 1)

TraySetClick(16)
TraySetIcon("Shell32.dll", -35)
TraySetOnEvent($TRAY_EVENT_PRIMARYUP, "_Tray_Main_Events")

$ViewMode_TrayMenu = TrayCreateMenu("  >>")

$NormalViewMode_TrayItem = TrayCreateItem("", $ViewMode_TrayMenu, -1, 1)
TrayItemSetOnEvent(-1, "_Tray_Main_Events")
TrayItemSetState(-1, $TRAY_CHECKED)

$MaxViewMode_TrayItem = TrayCreateItem("", $ViewMode_TrayMenu, -1, 1)
TrayItemSetOnEvent(-1, "_Tray_Main_Events")
If $iView_Mode = 2 Then TrayItemSetState(-1, $TRAY_CHECKED)

TrayCreateItem("")

$SettingsGUI_TrayItem = TrayCreateItem("")
TrayItemSetOnEvent(-1, "_Tray_Main_Events")

$SettingsFile_TrayItem = TrayCreateItem("  ...")
TrayItemSetOnEvent(-1, "_Tray_Main_Events")

TrayCreateItem("")

$Exit_TrayItem = TrayCreateItem("")
TrayItemSetOnEvent(-1, "_Tray_Main_Events")

#EndRegion Tray Part
;

#Region GUI Part
HotKeySet($sShow_MainGUI_HotKey, "_ShowHide_MainGUI_Proc")
HotKeySet($sHide_MainGUI_HotKey, "_ShowHide_MainGUI_Proc")

Opt("GUICloseOnESC", 0)

$hBk_GUI = GUICreate($sAppName, $iGUI_Width, $iGUI_Height, $iGUI_Left, $iGUI_Top, _
	BitOR($WS_POPUP, $WS_SIZEBOX), BitOR($WS_EX_TOPMOST, $WS_EX_TOOLWINDOW))

WinSetTrans($hBk_GUI, "", $aTransparency[$iCurrent_Transparency])
GUISetBkColor($aBk_Colors[$iCurrent_Bk_Color], $hBk_GUI)
GUISetCursor(0, 1, $hBk_GUI)
GUISetIcon("Shell32.dll", -35, $hBk_GUI)

$hLine_GUI = GUICreate("", @DesktopWidth, $iLine_Height, 0, $iTop_MaxVMode, $WS_POPUP, $WS_EX_TOPMOST, $hBk_GUI)
GUISetBkColor($iLine_Color, $hLine_GUI)

If $iView_Mode = 1 Then
	WinMove($hBk_GUI, "", $iGUI_Left, $iGUI_Top, $iGUI_Width, $iGUI_Height)
	
	$aBkGUI_Pos = WinGetPos($hBk_GUI)
	WinMove($hLine_GUI, "", $aBkGUI_Pos[0]+2, ($aBkGUI_Pos[1]+$aBkGUI_Pos[3])-($iLine_Height+3), $aBkGUI_Pos[2]-5)
	
	GUISetState(@SW_SHOW, $hBk_GUI)
	
	If $iShowCursor_NormalVMode = 0 Then
		GUISetCursor(16, 1, $hBk_GUI)
		GUISetCursor(16, 1, $hLine_GUI)
	EndIf
	
	$iMoveWithCursor = 0
Else
	If $iShowCursor_MaxVMode = 0 Then GUISetCursor(16, 1, $hBk_GUI)
	$iMoveWithCursor = 1
EndIf

GUISetState(@SW_SHOW, $hLine_GUI)

GUIRegisterMsg($WM_MOUSEWHEEL, "WM_MOUSEWHEEL")
GUIRegisterMsg($WM_MOVE, "WM_MOVE")
GUIRegisterMsg($WM_SIZE, "WM_MOVE")
GUIRegisterMsg($WM_NCHITTEST, "WM_NCHITTEST")
GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")
GUIRegisterMsg($WM_EXITSIZEMOVE, "WM_EXITSIZEMOVE")
GUIRegisterMsg($WM_SYSCOMMAND, "WM_SYSCOMMAND")

;~ $nESC_CtrlID = GUICtrlCreateDummy()

;~ Dim $aAccelKeys[1][2] = [["^q", $nESC_CtrlID]]

;~ GUISetAccelerators($aAccelKeys, $hBk_GUI)
;~ GUISetAccelerators($aAccelKeys, $hLine_GUI)
#EndRegion GUI Part
;

While 1
	$nMsg = GUIGetMsg(1)
	
	Switch $nMsg[0]
		Case $GUI_EVENT_CLOSE, $nSts_Cancel_Button
			If $nMsg[1] = $hSettings_GUI Then
				GUIDelete($hSettings_GUI)
				$hSettings_GUI = -1
			Else
				_Exit_Proc()
			EndIf
		Case $nSts_LineColor_Button
			Local $s_Color = _ChooseColor(2, $iLine_Color, 2, $hSettings_GUI)
			
			If Not @error Then
				$iLine_Color = $s_Color
				GUICtrlSetBkColor($nSts_LineColor_Button, $s_Color)
				ContinueCase
			EndIf
		Case $nSts_BkColor_Input To $nSts_MaxVMode_ShowCursor_CB
			GUICtrlSetState($nSts_Apply_Button, $GUI_ENABLE)
		Case $nSts_Apply_Button, $nSts_OK_Button
			GUICtrlSetState($nSts_Apply_Button, $GUI_DISABLE)
			
			$iCurrent_Bk_Color = GUICtrlRead($nSts_BkColor_Input)
			$iCurrent_Transparency = GUICtrlRead($nSts_Trans_Input)
			
			$iLine_Height = GUICtrlRead($nSts_LineHeight_Input)
			
			$iShowCursor_NormalVMode = Number(GUICtrlRead($nSts_NormalVMode_ShowCursor_CB) = $GUI_CHECKED)
			$iShowCursor_MaxVMode = Number(GUICtrlRead($nSts_MaxVMode_ShowCursor_CB) = $GUI_CHECKED)
			
			GUISetBkColor($aBk_Colors[$iCurrent_Bk_Color], $hBk_GUI)
			GUISetBkColor($iLine_Color, $hLine_GUI)
			WinSetTrans($hBk_GUI, "", $aTransparency[$iCurrent_Transparency])
			
			$aLineGUI_Pos = WinGetPos($hLine_GUI)
			
			WinMove($hLine_GUI, "", $aLineGUI_Pos[0], $aLineGUI_Pos[1], $aLineGUI_Pos[2], $iLine_Height)
			
			If $iView_Mode = 1 Then
				GUISetCursor(16, 1, $hBk_GUI)
				GUISetCursor(16, 1, $hLine_GUI)
				
				If $iShowCursor_NormalVMode = 1 Then
					GUISetCursor(0, 1, $hBk_GUI)
					GUISetCursor(0, 1, $hLine_GUI)
				EndIf
			Else
				GUISetCursor(16, 1, $hLine_GUI)
				If $iShowCursor_MaxVMode = 1 Then GUISetCursor(0, 1, $hLine_GUI)
			EndIf
			
			_SaveSettings_Proc()
			
			If $nMsg[0] = $nSts_OK_Button Then
				GUIDelete($hSettings_GUI)
				$hSettings_GUI = -1
			EndIf
		Case $nSts_ResDefaults_Button
			$iAsk_Reset = MsgBox(52, $sAppName & " - ", _
				"      , ?" & @CRLF & @CRLF & _
				"(  )", 0, $hSettings_GUI)
			
			If $iAsk_Reset <> 6 Then ContinueLoop
			
			FileDelete($sConfigFile)
			
			$sRunScript_Line = @AutoItExe & ' /ErrorStdOut /AutoIt3ExecuteScript "' & @ScriptFullPath & '"'
			If @Compiled Then $sRunScript_Line = @AutoItExe
			
			Run($sRunScript_Line, @ScriptDir)
			Exit
	EndSwitch
	
	If _IsPressed("04", $hUser32_Dll) Then ;Middle mouse button
		While _IsPressed("04", $hUser32_Dll)
			Sleep(10)
		WEnd
		
		$iView_Mode = (3 - $iView_Mode)
		_SetViewMode_Proc()
	EndIf
	
	If $iMoveWithCursor Then
		$aMouse_Pos = MouseGetPos()
		
		If $aMouse_Pos[0] <> $aOld_Mouse_Pos[0] Or $aMouse_Pos[1] <> $aOld_Mouse_Pos[1] Then
			If $iView_Mode = 1 Then
				$aBkGUI_Pos = WinGetPos($hBk_GUI)
				
				Local $i_Left, $i_Top
				
				If $aMouse_Pos[0] > $aOld_Mouse_Pos[0] Then
					$i_Left = $aBkGUI_Pos[0] + ($aMouse_Pos[0] - $aOld_Mouse_Pos[0])
				Else
					$i_Left = $aBkGUI_Pos[0] - ($aOld_Mouse_Pos[0] - $aMouse_Pos[0])
				EndIf
				
				If $aMouse_Pos[1] > $aOld_Mouse_Pos[1] Then
					$i_Top = $aBkGUI_Pos[1] + ($aMouse_Pos[1] - $aOld_Mouse_Pos[1])
				Else
					$i_Top = $aBkGUI_Pos[1] - ($aOld_Mouse_Pos[1] - $aMouse_Pos[1])
				EndIf
				
				WinMove($hBk_GUI, "", $i_Left, $i_Top)
				WinMove($hLine_GUI, "", $i_Left+2, ($i_Top+$aBkGUI_Pos[3])-13)
			Else
				WinMove($hLine_GUI, "", 0, $aMouse_Pos[1]+10)
			EndIf
			
			$aOld_Mouse_Pos = $aMouse_Pos
		EndIf
	EndIf
WEnd

Func _Tray_Main_Events()
	Switch @TRAY_ID
		Case $TRAY_EVENT_PRIMARYUP
			_ShowHide_MainGUI_Proc()
		Case $NormalViewMode_TrayItem
			$iView_Mode = 1
			_SetViewMode_Proc()
		Case $MaxViewMode_TrayItem
			$iView_Mode = 2
			_SetViewMode_Proc()
		Case $SettingsGUI_TrayItem
			_SettingsGUI_Proc()
		Case $SettingsFile_TrayItem
			If FileExists($sConfigFile) Then
				ShellExecute($sConfigFile, "", @ScriptDir, "", @SW_MAXIMIZE)
			Else
				GUISetState(@SW_DISABLE, $hBk_GUI)
				GUISetState(@SW_DISABLE, $hLine_GUI)
				
				MsgBox(48, $sAppName & " - !", _
					"   ,     .", 0, $hLine_GUI)
				
				GUISetState(@SW_ENABLE, $hBk_GUI)
				GUISetState(@SW_ENABLE, $hLine_GUI)
			EndIf
		Case $Exit_TrayItem
			_Exit_Proc()
	EndSwitch
EndFunc

Func _ShowHide_MainGUI_Proc()
	If $iMainGUI_IsShown Then
		GUISetState(@SW_HIDE, $hBk_GUI)
		GUISetState(@SW_HIDE, $hLine_GUI)
	Else
		If $iView_Mode = 1 Then GUISetState(@SW_SHOW, $hBk_GUI)
		GUISetState(@SW_SHOW, $hLine_GUI)
	EndIf
	
	$iMainGUI_IsShown = Not $iMainGUI_IsShown
EndFunc

Func _SetViewMode_Proc()
	Switch $iView_Mode
		Case 1
			WinMove($hBk_GUI, "", $iLeft_NormalVMode, $iTop_NormalVMode, $iWidth_NormalVMode, $iHeight_NormalVMode)
			WinMove($hLine_GUI, "", $iLeft_NormalVMode+2, ($iTop_NormalVMode+$iHeight_NormalVMode)-($iLine_Height+3), _
				$iWidth_NormalVMode-5, $iLine_Height)
			
			If $iMainGUI_IsShown Then GUISetState(@SW_SHOW, $hBk_GUI)
			
			If $iShowCursor_NormalVMode = 1 Then
				GUISetCursor(0, 1, $hBk_GUI)
				GUISetCursor(0, 1, $hLine_GUI)
			Else
				GUISetCursor(16, 1, $hBk_GUI)
				GUISetCursor(16, 1, $hLine_GUI)
			EndIf
			
			TrayItemSetState($NormalViewMode_TrayItem, $TRAY_CHECKED)
			TrayItemSetState($MaxViewMode_TrayItem, $TRAY_UNCHECKED)
			
			$iMoveWithCursor = 0
		Case Else
			GUISetState(@SW_HIDE, $hBk_GUI)
			WinMove($hLine_GUI, "", 0, $iTop_MaxVMode, @DesktopWidth, $iLine_Height)
			
			If $iShowCursor_MaxVMode = 1 Then
				GUISetCursor(0, 1, $hBk_GUI)
				GUISetCursor(0, 1, $hLine_GUI)
			Else
				GUISetCursor(16, 1, $hBk_GUI)
				GUISetCursor(16, 1, $hLine_GUI)
			EndIf
			
			TrayItemSetState($NormalViewMode_TrayItem, $TRAY_UNCHECKED)
			TrayItemSetState($MaxViewMode_TrayItem, $TRAY_CHECKED)
			
			$iMoveWithCursor = 1
	EndSwitch
EndFunc

Func _SettingsGUI_Proc()
	If IsHWnd($hSettings_GUI) Then Return WinActivate($hSettings_GUI)
	
	$hSettings_GUI = GUICreate($sAppName & " - ", 500, 400, -1, -1, -1, $WS_EX_TOOLWINDOW, $hLine_GUI)
	
	#Region General Settings
	GUICtrlCreateGroup("", 10, 20, 480, 105)
	
	GUICtrlCreateLabel("  :", 20, 40, 135, 15)
	$nSts_BkColor_Input = GUICtrlCreateInput($iCurrent_Bk_Color, 155, 38, 90, 20, $ES_READONLY)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, $aBk_Colors[0], 1)
	
	GUICtrlCreateLabel(" :", 20, 100, -1, 15)
	$nSts_Trans_Input = GUICtrlCreateInput($iCurrent_Transparency, 155, 98, 90, 20, $ES_READONLY)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, $aTransparency[0], 1)
	
	GUICtrlCreateLabel("  :", 270, 50, -1, 15)
	$nSts_LineHeight_Input = GUICtrlCreateInput($iLine_Height, 410, 48, 75, 20, $ES_READONLY)
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 15, 5)
	
	GUICtrlCreateLabel("  :", 270, 100, -1, 15)
	$nSts_LineColor_Button = GUICtrlCreateButton("", 395, 98, 90, 20)
	GUICtrlSetBkColor(-1, $iLine_Color)
	#EndRegion General Settings
	;
	
	#Region "Normal Mode" Settings
	GUICtrlCreateGroup(" ", 10, 140, 480, 100)
	
	$nSts_NormalVMode_ShowCursor_CB = GUICtrlCreateCheckbox(" ", 20, 160)
	If $iShowCursor_NormalVMode = 1 Then GUICtrlSetState(-1, $GUI_CHECKED)
	#EndRegion "Normal Mode" Settings
	;
	
	#Region "Max Mode" Settings
	GUICtrlCreateGroup(" ", 10, 260, 480, 100)
	
	$nSts_MaxVMode_ShowCursor_CB = GUICtrlCreateCheckbox(" ", 20, 280)
	If $iShowCursor_MaxVMode = 1 Then GUICtrlSetState(-1, $GUI_CHECKED)
	#EndRegion "Max Mode" Settings
	;
	
	$nSts_Apply_Button = GUICtrlCreateButton("", 20, 370, 70, 20)
	GUICtrlSetState(-1, $GUI_DISABLE)
	
	$nSts_OK_Button = GUICtrlCreateButton("OK", 120, 370, 60, 20)
	$nSts_Cancel_Button = GUICtrlCreateButton("", 185, 370, 60, 20)
	
	$nSts_ResDefaults_Button = GUICtrlCreateButton(" ", 375, 370, 115, 20)
	
	GUISetState(@SW_SHOW, $hSettings_GUI)
EndFunc

Func _SaveSettings_Proc()
	IniWrite($sConfigFile, "Main", "Line Color", $iLine_Color)
	IniWrite($sConfigFile, "Main", "Line Height", $iLine_Height)
	IniWrite($sConfigFile, "Main", "Bk Color Level", $iCurrent_Bk_Color)
	IniWrite($sConfigFile, "Main", "Transparency Level", $iCurrent_Transparency)
	
	IniWrite($sConfigFile, "Normal View Mode", "Show Cursor", $iShowCursor_NormalVMode)
	IniWrite($sConfigFile, "Max View Mode", "Show Cursor", $iShowCursor_MaxVMode)
	
	IniWrite($sConfigFile, "Main", "Bk Color Level", $iCurrent_Bk_Color)
	IniWrite($sConfigFile, "Main", "Transparency Level", $iCurrent_Transparency)
	
	IniWrite($sConfigFile, "Main", "View Mode", $iView_Mode)
	
	IniWrite($sConfigFile, "Max View Mode", "GUI Width", $iWidth_MaxVMode)
	IniWrite($sConfigFile, "Max View Mode", "GUI Height", $iHeight_MaxVMode)
	IniWrite($sConfigFile, "Max View Mode", "GUI Left", $iLeft_MaxVMode)
	IniWrite($sConfigFile, "Max View Mode", "GUI Top", $iTop_MaxVMode)
	
	IniWrite($sConfigFile, "Max View Mode", "Show Cursor", $iShowCursor_MaxVMode)
	
	IniWrite($sConfigFile, "Normal View Mode", "GUI Width", $iWidth_NormalVMode)
	IniWrite($sConfigFile, "Normal View Mode", "GUI Height", $iHeight_NormalVMode)
	IniWrite($sConfigFile, "Normal View Mode", "GUI Left", $iLeft_NormalVMode)
	IniWrite($sConfigFile, "Normal View Mode", "GUI Top", $iTop_NormalVMode)
	
	IniWrite($sConfigFile, "Normal View Mode", "Show Cursor", $iShowCursor_NormalVMode)
EndFunc

Func WM_MOUSEWHEEL($hWnd, $iMsg, $wParam, $lParam)
	If _IsPressed("10", $hUser32_Dll) Then
		Switch $wParam
			Case 0x00780004 ;Wheel Up
				$iCurrent_Bk_Color += 1
				If $iCurrent_Bk_Color >= $aBk_Colors[0] Then $iCurrent_Bk_Color = 1
				
				GUISetBkColor($aBk_Colors[$iCurrent_Bk_Color], $hBk_GUI)
			Case 0xFF880004 ;Wheel Down
				$iCurrent_Transparency += 1
				If $iCurrent_Transparency > $aTransparency[0] Then $iCurrent_Transparency = 1
				
				WinSetTrans($hBk_GUI, "", $aTransparency[$iCurrent_Transparency])
		EndSwitch
	EndIf
EndFunc

Func WM_NCHITTEST($hWnd, $iMsg, $wParam, $lParam)
	Local $iRet = _WinAPI_DefWindowProc($hWnd, $iMsg, $wParam, $lParam)
	
	If _IsPressed("01", $hUser32_Dll) And _IsPressed("02", $hUser32_Dll) Then ;Shift + Left mouse button
		While _IsPressed("01", $hUser32_Dll) And _IsPressed("02", $hUser32_Dll)
			Sleep(10)
		WEnd
		
		$aOld_Mouse_Pos = MouseGetPos()
		$iMoveWithCursor = Not $iMoveWithCursor
	EndIf
	
	If $iRet = 1 Then Return 2
	Return $iRet
EndFunc

Func WM_MOVE($hWnd, $MsgID, $wParam, $lParam)
	$aBkGUI_Pos = WinGetPos($hBk_GUI)
	$aLineGUI_Pos = WinGetPos($hLine_GUI)
	
	GUIRegisterMsg($WM_MOVE, "")
	GUIRegisterMsg($WM_SIZE, "")
	GUIRegisterMsg($WM_NCHITTEST, "")
	GUIRegisterMsg($WM_GETMINMAXINFO, "")
	
	If $hWnd = $hBk_GUI Then
		WinMove($hLine_GUI, "", $aBkGUI_Pos[0]+2, ($aBkGUI_Pos[1]+$aBkGUI_Pos[3])-($iLine_Height+3), $aBkGUI_Pos[2]-5)
	Else
		WinMove($hBk_GUI, "", $aLineGUI_Pos[0]-2, ($aLineGUI_Pos[1]-$aBkGUI_Pos[3])+($iLine_Height+3))
	EndIf
	
	If $iView_Mode = 1 Then
		$iWidth_NormalVMode = $aBkGUI_Pos[2]
		$iHeight_NormalVMode = $aBkGUI_Pos[3]
		$iLeft_NormalVMode = $aBkGUI_Pos[0]
		$iTop_NormalVMode = $aBkGUI_Pos[1]
	Else
		$iWidth_MaxVMode = @DesktopWidth
		$iHeight_MaxVMode = $aLineGUI_Pos[3]
		$iLeft_MaxVMode = 0
		$iTop_MaxVMode = $aLineGUI_Pos[1]
	EndIf
	
	GUIRegisterMsg($WM_MOVE, "WM_MOVE")
	GUIRegisterMsg($WM_SIZE, "WM_MOVE")
	GUIRegisterMsg($WM_NCHITTEST, "WM_NCHITTEST")
	GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")
EndFunc

Func WM_SYSCOMMAND($hWnd, $iMsg, $wParam, $lParam)
	Switch BitAND($wParam, 0xFFF0)
		Case $SC_SIZE, $SC_MOVE
			If BitAND($wParam, 0xFFF0) = $SC_SIZE And $iView_Mode = 2 Then Return 0
			
			Local Const $SPI_SETDRAGFULLWINDOWS = 37
			Local Const $SPI_GETDRAGFULLWINDOWS = 38
			Local Const $SPIF_SENDWININICHANGE = 2
			
			DllCall("User32.dll", "int", "SystemParametersInfo", _
				"int", $SPI_SETDRAGFULLWINDOWS, "int", 1, "ptr", 0, "int", $SPIF_SENDWININICHANGE)
	EndSwitch
EndFunc
    
Func WM_EXITSIZEMOVE($hWnd, $iMsg, $wParam, $lParam)
    DllCall("user32.dll", "int", "SystemParametersInfo", "int", 37, "int", $iOld_DragFullWindows_Opt, "ptr", 0, "int", 2)
EndFunc

Func WM_GETMINMAXINFO($hWnd, $iMsg, $wParam, $lParam)
	If $hWnd <> $hBk_GUI Then Return $GUI_RUNDEFMSG
	
	Local $MINGuiX = 600, $MINGuiY = 300, $MAXGuiX = @DesktopWidth, $MAXGuiY = @DesktopHeight
	Local $stMinMaxInfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
	
	DllStructSetData($stMinMaxInfo, 7, $MINGuiX) ; min X
	DllStructSetData($stMinMaxInfo, 8, $MINGuiY) ; min Y
	DllStructSetData($stMinMaxInfo, 9, $MAXGuiX) ; max X
	DllStructSetData($stMinMaxInfo, 10, $MAXGuiY) ; max Y
	
	Return $GUI_RUNDEFMSG
EndFunc

Func _Exit_Proc()
	_SaveSettings_Proc()
	Exit
EndFunc
